Version 1.00
BEGIN Form Form1
	AutoRedraw   = 0
	BackColor    = QBColor(7)
	BorderStyle  = 3
	Caption      = "Ansi-/Ascii-Konvertierung"
	ControlBox   = -1
	Enabled      = -1
	ForeColor    = QBColor(0)
	Height       = Char(15)
	Left         = Char(10)
	MaxButton    = 0
	MinButton    = -1
	MousePointer = 0
	Tag          = ""
	Top          = Char(5)
	Visible      = -1
	Width        = Char(48)
	WindowState  = 0
	BEGIN Label Bezeichnung4
		Alignment    = 0
		AutoSize     = 0
		BackColor    = QBColor(7)
		BorderStyle  = 0
		Caption      = "&Suchen in:"
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(1)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 8
		Tag          = ""
		Top          = Char(3)
		Visible      = -1
		Width        = Char(16)
	END
	BEGIN DriveListBox Laufwerk1
		BackColor    = QBColor(7)
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(1)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 5
		TabStop      = -1
		Tag          = ""
		Top          = Char(4)
		Visible      = -1
		Width        = Char(16)
	END
	BEGIN DirListBox Verzeichnis1
		BackColor    = QBColor(7)
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(8)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 6
		TabStop      = -1
		Tag          = ""
		Top          = Char(5)
		Visible      = -1
		Width        = Char(16)
	END
	BEGIN Label Bezeichnung2
		Alignment    = 0
		AutoSize     = 0
		BackColor    = QBColor(7)
		BorderStyle  = 0
		Caption      = "&Dateien whlen:"
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(1)
		Left         = Char(19)
		MousePointer = 0
		TabIndex     = 7
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(16)
	END
	BEGIN FileListBox Datei1
		Archive      = -1
		BackColor    = QBColor(7)
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(11)
		Hidden       = 0
		Left         = Char(19)
		MousePointer = 0
		Normal       = -1
		Pattern      = "*.*"
		ReadOnly     = -1
		System       = 0
		TabIndex     = 9
		TabStop      = -1
		Tag          = ""
		Top          = Char(2)
		Visible      = -1
		Width        = Char(15)
	END
	BEGIN CommandButton Befehl2
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "A&sc2Ans"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(36)
		MousePointer = 0
		TabIndex     = 1
		TabStop      = -1
		Tag          = ""
		Top          = Char(4)
		Visible      = -1
		Width        = Char(9)
	END
	BEGIN CommandButton Befehl3
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "&Info"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(36)
		MousePointer = 0
		TabIndex     = 2
		TabStop      = -1
		Tag          = ""
		Top          = Char(7)
		Visible      = -1
		Width        = Char(9)
	END
	BEGIN CommandButton Befehl4
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "Ende"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(36)
		MousePointer = 0
		TabIndex     = 3
		TabStop      = -1
		Tag          = ""
		Top          = Char(10)
		Visible      = -1
		Width        = Char(9)
	END
	BEGIN Label Bezeichnung1
		Alignment    = 0
		AutoSize     = 0
		BackColor    = QBColor(7)
		BorderStyle  = 0
		Caption      = "CONVERT"
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(4)
		Height       = Char(2)
		Left         = Char(3)
		MousePointer = 0
		TabIndex     = 4
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(14)
	END
	BEGIN CommandButton Befehl1
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "A&ns2Asc"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(3)
		Left         = Char(36)
		MousePointer = 0
		TabIndex     = 0
		TabStop      = -1
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(9)
	END
END
DECLARE FUNCTION Ans2Asc$ (AnsiZeile$)
DECLARE SUB AnsiMakeAscii (Quelldatei$, Zieldatei$)
DECLARE FUNCTION Asc2Ans$ (AsciiZeile$)
DECLARE SUB AsciiMakeAnsi (Quelldatei$, Zieldatei$)
DECLARE FUNCTION RemoveSuffix$ (Datei$)

'**********************************************************
'* CONVERT - Ansi- zu Ascii- und Ascii- zu Ansi-Converter *
'*           DOS-Variante; hier sind Nachbildungen der    *
'*           Windows-API-Routinen AnsiToOem und OemToAnsi *
'*           erforderlich!                                *
'*                                                        *
'* (c)1993 by Dipl.-Ing. Andreas Maslo                    *
'**********************************************************

'ASCII-Codes
DIM SHARED ASCII$

'ANSI-Codes
DIM SHARED ANSI$

'aktuelles Listenfeld
DIM AktuelleListe%

FUNCTION Ans2Asc$ (AnsiZeile$)
  'Zeile im ANSI-Format zeichenweise
  'untersuchen und umwandeln
  'Funktion erzeugt eine Kopie der Ursprungs-
  'zeichenkette
  Temp$ = ""
  FOR x% = 1 TO LEN(AnsiZeile$)
    Zeichen$ = MID$(AnsiZeile$, x%, 1)
    'Austausch fr Zeichen erforderlich?
    Nummer% = INSTR(ANSI$, Zeichen$)
    IF Nummer% > 0 THEN
      'Zeichen ersetzen
      Zeichen$ = MID$(ASCII$, Nummer%, 1)
    END IF
    Temp$ = Temp$ + Zeichen$
  NEXT x%
  Ans2Asc$ = Temp$
END FUNCTION

SUB AnsiMakeAscii (Quelldatei$, Zieldatei$)
  'ANSI-Datei in ASCII-Datei umwandeln
  'Dateinummern ermitteln
  QNr = FREEFILE
  ZNr = QNr + 1
  'Dateien ffnen
  OPEN Quelldatei$ FOR INPUT AS #QNr
  OPEN Zieldatei$ FOR OUTPUT AS #ZNr
  'zeilenweise lesen und bersetzen
  'konvertierte Datei anlegen
  WHILE NOT EOF(QNr)
    LINE INPUT #QNr, Zeile$
    PRINT #ZNr, Ans2Asc$(Zeile$)
  WEND
  CLOSE #QNr
  CLOSE #ZNr
END SUB

FUNCTION Asc2Ans$ (AsciiZeile$)
  'Zeile im ASCII-Format zeichenweise
  'untersuchen und umwandeln
  'Funktion erzeugt eine Kopie der Ursprungs-
  'zeichenkette
  Temp$ = ""
  FOR x% = 1 TO LEN(AsciiZeile$)
    Zeichen$ = MID$(AsciiZeile$, x%, 1)
    'Austausch fr Zeichen erforderlich?
    Nummer% = INSTR(ASCII$, Zeichen$)
    IF Nummer% > 0 THEN
      'Zeichen ersetzen
      Zeichen$ = MID$(ANSI$, Nummer%, 1)
    END IF
    Temp$ = Temp$ + Zeichen$
  NEXT x%
  Asc2Ans$ = Temp$
END FUNCTION

SUB AsciiMakeAnsi (Quelldatei$, Zieldatei$)
  'ASCII-Datei in ANSI-Datei umwandeln
  'Dateinummern ermitteln
  QNr = FREEFILE
  ZNr = QNr + 1
  'Dateien ffnen
  OPEN Quelldatei$ FOR INPUT AS #QNr
  OPEN Zieldatei$ FOR OUTPUT AS #ZNr
  'zeilenweise lesen und bersetzen
  'konvertierte Datei anlegen
  WHILE NOT EOF(QNr)
    LINE INPUT #QNr, Zeile$
    PRINT #ZNr, Asc2Ans$(Zeile$)
  WEND
  CLOSE #QNr
  CLOSE #ZNr
END SUB

SUB Befehl1_Click ()
  'konvertiere die ausgewhlte Datei im Listenfeld
  'vom ANSI- in das ASCII-Format
  'aktueller Pfad
  Pfad$ = Verzeichnis1.Path
  IF RIGHT$(Pfad$, 1) <> "\" THEN
    Pfad$ = Pfad$ + "\"
  END IF
  Datei$ = Datei1.List(Datei1.ListIndex)
  'Quelldatei mit Suchpfad
  Quelle$ = Pfad$ + Datei$
  IF RIGHT$(Datei$, 3) <> "ASC" AND Datei$ <> "" THEN
    'ASCII-Dateien knnen nicht mehr bersetzt werden,
    'da Zieldatei identisch mit Quelldatei
    '(Namenskonflikt!)
    Ziel$ = RemoveSuffix$(Quelle$) + "ASC"
    Form1.Caption = "konvertiere " + Quelle$ + "..."
    AnsiMakeAscii Quelle$, Ziel$
    Form1.Caption = "Ansi-/Ascii-Konvertierung"
  END IF
END SUB

SUB Befehl2_Click ()
  'konvertiere die ausgewhlten Dateien im Listenfeld
  'nacheinander vom ASCII- in das ANSI-Format
  'aktueller Pfad
  Pfad$ = Verzeichnis1.Path
  IF RIGHT$(Pfad$, 1) <> "\" THEN
    Pfad$ = Pfad$ + "\"
  END IF
  Datei$ = Datei1.List(Datei1.ListIndex)
  'Quelldatei mit Suchpfad
  Quelle$ = Pfad$ + Datei$
  IF RIGHT$(Datei$, 3) <> "ANS" AND Datei$ <> "" THEN
    'ANSI-Dateien knnen nicht mehr bersetzt werden,
    'da Zieldatei identisch mit Quelldatei
    '(Namenskonflikt!)
    Ziel$ = RemoveSuffix$(Quelle$) + "ANS"
    Form1.Caption = "konvertiere " + Quelle$ + "..."
    AsciiMakeAnsi Quelle$, Ziel$
    Form1.Caption = "Ansi-/Ascii-Konvertierung"
  END IF
END SUB

SUB Befehl3_Click ()
  'Kurzinformation...
  CL$ = CHR$(13) + CHR$(10)
  Titel$ = "Information"
  'Info-Symbol, <OK>-Schaltflche
  Typ% = 64
  Msg$ = "Whlen Sie eine Datei mit dem Doppelklick aus dem Dateilistenfeld."
  Msg$ = Msg$ + "Mit <Ans2Asc> wandeln Sie die angewhlten "
  Msg$ = Msg$ + "ANSI-Dateien in das ASCII-Format um. "
  Msg$ = Msg$ + " Die umgekehrte Konvertierung rufen Sie mit <Asc2Ans> ab. "
  Msg$ = Msg$ + "Beachten Sie, da die Formate intern nicht kontrolliert werden. "
  Msg$ = Msg$ + "Arbeiten Sie daher mit Sicherheitskopien Ihrer Dateien." + CL$
  MSGBOX Msg$, Typ%, Titel$
END SUB

SUB Befehl4_Click ()
  'Programm beenden...
  Titel$ = "Programm beenden..."
  Msg$ = "Wollen Sie das Programm wirklich beenden?"
  'Fragezeichen und <Ja>/<Nein>
  Typ% = 32 + 4
  a% = MSGBOX(Msg$, Typ%, Titel$)
  IF a% = 6 THEN
    END
  END IF
END SUB

SUB Datei1_Click ()

END SUB

SUB Form_Load ()
  'Ursprungspfad merken
  Ursprungspfad$ = CURDIR$
  'Suchmaske fr Textdateien
  Datei1.Pattern = "*.BA*;*.TXT;*.LST;*.C;*.ASC;*.ANS;*.DO*"
  'auszutauschende Zeichen definieren                        (Dateien *.ANS werden in Liste ignoriert)
  ASCII$ = CHR$(156) + CHR$(21) + CHR$(34) + CHR$(174) + CHR$(45)
  ASCII$ = ASCII$ + CHR$(241) + CHR$(253) + CHR$(248) + CHR$(175) + CHR$(172)
  ASCII$ = ASCII$ + CHR$(171) + CHR$(142) + CHR$(153) + CHR$(120) + CHR$(154)
  ASCII$ = ASCII$ + CHR$(225) + CHR$(132) + CHR$(148) + CHR$(246) + CHR$(129)
  ANSI$ = CHR$(163) + CHR$(167) + CHR$(168) + CHR$(171) + CHR$(173)
  ANSI$ = ANSI$ + CHR$(177) + CHR$(178) + CHR$(186) + CHR$(187) + CHR$(188)
  ANSI$ = ANSI$ + CHR$(189) + CHR$(196) + CHR$(214) + CHR$(215) + CHR$(220)
  ANSI$ = ANSI$ + CHR$(223) + CHR$(228) + CHR$(246) + CHR$(247) + CHR$(252)
END SUB

SUB Laufwerk1_Change ()
  'Verzeichnislistenfeld das neu angewhlte
  'Laufwerk mitteilen...
  Verzeichnis1.Path = Laufwerk1.Drive
END SUB

FUNCTION RemoveSuffix$ (Datei$)
  'nderungen an Zeichenkettenkopie vornehmen,
  'um die Variable im Hauptprogramm nicht zu
  'beeinflussen
  File$ = Datei$
  'Dateikrzel ohne Punk entfernen
  WHILE Zeichen$ <> "."
    Zeichen$ = RIGHT$(File$, 1)
    IF Zeichen$ <> "." THEN
      'Zeichen entfernen, bis Punkt erreicht
      File$ = LEFT$(File$, LEN(File$) - 1)
    END IF
  WEND
  'Ergebnis zurckgeben
  RemoveSuffix$ = File$
END FUNCTION

SUB Verzeichnis1_Change ()
  'gewhltes Arbeitsverzeichnis an
  'Dateilistenfeld weiterleiten
  Datei1.Path = Verzeichnis1.Path
END SUB

